/* $Workfile: OsaWin32Def.h $   $Revision: 2 $    $Modtime: 4/02/13 9:27a $  */
#ifndef OSA_WIN32_DEF_H
#define OSA_WIN32_DEF_H
/*******************************************************************************

  @doc PublicHwApi OsaWin32Def

  Copyright (C) 1999-2008 Odin TeleSystems Inc., All Rights Reserved

  OTX Generic Hardware Driver API

  @module
  OsaWin32Def | This file contains types and macros for the Win32
  version of the platform generic Osa implementation 
  (used by the demo programs)

  @contents2
  OsaWin32Def.h |

  @index func | OsaWin32Def

  @contents2
  Win32 Osa Types and Macros | Types and macros for the Win32
  version of the platform generic Osa implementation 
  (used by the demo programs)

*******************************************************************************/

#ifndef OSA_DEF_H
#error This file should only be included from OsaDef.h
#endif


#if !OSA_WIN32 && !WIN32
#error "This file should only be included in Kernel mode OSA_WIN32 or user mode WIN32 code"
#endif

#if __cplusplus
extern "C" {
#endif

#define OSA_CDECL _cdecl

// All Win32 configurations use the same types
// We don't even need a system header for it
#if defined(_M_AMD64)
typedef void             *OsaPMDL;
typedef unsigned __int64 OsaSysAddr;
typedef unsigned __int64 OsaUint64;
typedef unsigned __int32 OsaUint32;
typedef unsigned __int16 OsaUint16;
typedef unsigned __int8  OsaUint8;
typedef signed   __int64 OsaInt64;
typedef signed   __int32 OsaInt32;
typedef signed   __int16 OsaInt16;
typedef signed   __int8  OsaInt8;
typedef double           OsaFp64;
typedef void             OsaVoid;
typedef void            *OsaVoidP;
typedef unsigned __int16 OsaWchar, *OsaWcharP;
#else
typedef void             *OsaPMDL;
typedef unsigned __int64 OsaUint64;
typedef unsigned __int32 OsaSysAddr;
typedef unsigned long    OsaUint32;
typedef unsigned short   OsaUint16;
typedef unsigned char    OsaUint8;
typedef signed   __int64 OsaInt64;
typedef signed   long    OsaInt32;
typedef signed   short   OsaInt16;
typedef signed   char    OsaInt8;
typedef double           OsaFp64;
typedef void             OsaVoid, *OsaVoidP;
typedef unsigned short   OsaWchar, *OsaWcharP;

#endif

typedef unsigned long    OsaULong;  //32 bits in 32-bit system; 64 bits in 64-bit system

#if __cplusplus
}
#endif

/*******************************************************************************

  Copyright (C) Odin TeleSystems Inc., 1999-2008

  All rights reserved. No part of this computer program may be reproduced,
  stored in any retrieval system, or transmitted, in any form or by any
  means, electronic, mechanical, photocopying, recording, or otherwise,
  without the prior written permission of Odin TeleSystems Inc., or without
  a permission stipulated in the agreement/contract under which this computer
  program was supplied.

*******************************************************************************/
#endif // OSA_WIN32_DEF_H
